#ifndef DRM_OBJECT_H_
#define DRM_OBJECT_H_

#include "drm_context.h"

struct drm_object {
   uint32_t blob_id;
   uint32_t res_id;
   uint32_t handle;
   uint32_t flags;
   uint32_t size;
   uint32_t prime_fd;
   bool exported   : 1;
   bool exportable : 1;
   struct virgl_resource *res;
   uint8_t *map;
};

struct drm_object *drm_object_create(uint32_t handle, uint32_t flags, uint32_t size, uint32_t prime_fd);

bool drm_valid_blob_id(struct drm_context *dctx, uint32_t blob_id);

void drm_object_set_blob_id(struct drm_context *dctx, struct drm_object *obj,
                            uint32_t blob_id);

bool drm_valid_res_id(struct drm_context *dctx, uint32_t res_id);

void drm_object_set_res_id(struct drm_context *dctx, struct drm_object *obj,
                           uint32_t res_id);

void drm_remove_object(struct drm_context *dctx, struct drm_object *obj);

struct drm_object *drm_retrieve_object_from_blob_id(struct drm_context *dctx,
                                                    uint64_t blob_id);

struct drm_object *drm_get_object_from_res_id(struct drm_context *dctx, uint32_t res_id);

uint32_t drm_handle_from_res_id(struct drm_context *dctx, uint32_t res_id);

#endif // DRM_OBJECT_H_
