/*
 * Copyright 2022 Google LLC
 * SPDX-License-Identifier: MIT
 */

#include <stdarg.h>
#include <string.h>

#include "drm_util.h"
#include "virgl_util.h"

#include "util/hash_table.h"
#include "util/macros.h"

struct hash_entry *
drm_table_search(struct hash_table *ht, uint32_t key)
{
   /* zero is not a valid key for u32_keys hashtable: */
   if (!key)
      return NULL;
   return _mesa_hash_table_search(ht, (void *)(uintptr_t)key);
}

void
_drm_log(const char *fmt, ...)
{
   va_list va;

   va_start(va, fmt);
   virgl_prefixed_logv("drm", VIRGL_LOG_LEVEL_INFO, fmt, va);
   va_end(va);
}
